def build_dfa(pat, alph):
    '''Gibt einen DFA aus Muster und Alphabet zurück.'''
    m = len(pat)
    delta = [dict() for i in range(0, m+1)]

    for q in range(0, m+1):
        for x in alph:
            s1 = pat[:q] + x
            for k in range(m, -1, -1):
                s2 = pat[:k]
                if s1.endswith(s2):
                    delta[q][x] = k
                    break

    return delta


def matcher_dfa(pat, text, alph):
    '''Gibt eine Liste mit den Anfangspositionen 
    der Matches zurück.'''
    matches = []
    delta = build_dfa(pat, alph)
    q = 0
    m = len(pat)
    for i, c in enumerate(text):
        q = delta[q][text[i]]
        if q == m:
            matches.append(i-m+1)
    return matches


if __name__ == "__main__":


    alph = 'abc'
    text = 'aaaabababababc'
    pat = 'ababc'

    dfa = build_dfa(pat, alph)
    matches = matcher_dfa(pat, text, alph)

    print('Muster:', pat)

    print('Muster-DFA:')
    for i in range(0, len(dfa)):
        print(i, dfa[i])

    print('Text:', text)
    print('Anfangspositionen der Übereinstimmung:', matches)
                   
    
        
                
                
                
            
